/* 
 * AC Voltage Sensor Modul with ARDUINO UNO von Peter Klingbeil modifiziert 2020
 * A Part of this code works with ZMPT101B AC voltage sensor module 
 * It permits you to measure any AC voltage up to 250V, BE CAREFUL !!!
 * The functions from Filters library permits you to calculate the True RMS of a signal
 * Refer to www.surtrTech.com or SurtrTech YouTube channel for more details
 * https://surtrtech.com/2020/04/08/measure-any-ac-voltage-250vac-with-zmpt101b-and-esp8266-12e-with-android-app-adafruit-io-mqtt/
 */

#include <Wire.h>
#include <String.h>
#include <Filters.h>  //Easy library to do the AC calculations 

 
// Globale Variablen   

  int Sensor = 0;                        // Sensor analog input, here it's A0
  char BUF[10];

  float testFrequency = 100;                    // test signal frequency 50(Hz)
  float windowLength = 40.0/testFrequency;     // how long to average the signal, for statistist 40.0/testFrequency
  float intercept = -0.04;               // to be adjusted based on calibration testing -0.04
  float slope = 0.0405;                  // to be adjusted based on calibration testing 0.0405
  float current_Volts;                   // Voltage

  unsigned long printPeriod = 1000;      //Refresh rate
  unsigned long previousMillis = 0;

void setup() 
{
  Wire.begin();                // I2C Bus
  Serial.begin(9600);          // Debuging
  while (!Serial);             // wait for serial monitor
  pinMode(7, INPUT_PULLUP);    // Sensor selektion  
  delay(1000);
  Serial.println("AC Sensor V1.1 start!");  // Versionsanzeige 
}

void loop() 
{
 
 RunningStatistics inputStats;                //Easy life lines, actual calculation of the RMS requires a load of coding
 inputStats.setWindowSecs( windowLength ); 
        
    while( true ) 
    {   

    Sensor = analogRead(A0);  // read the analog in value:
    inputStats.input(Sensor);  // log to Stats function
        
     if((unsigned long)(millis() - previousMillis) >= printPeriod) 
     {
      previousMillis = millis();   // update time every second
   
      current_Volts = intercept + slope * inputStats.sigma(); // Calibartions for offset and amplitude
      current_Volts= current_Volts*(40.3231);                 // Further calibrations for the amplitude
      current_Volts= current_Volts * 100;                     // 5 Stellen Auflösung ohne Nachkomma übertragen
      itoa(current_Volts,BUF,10);                             // Als String via I2C senden
      
      if (digitalRead(7) == LOW)            // CS
       {
       Wire.beginTransmission(8);           // start transmit to slave arduino #8
       Wire.write(BUF);                     // sends converted converted POT value to slave
       Wire.endTransmission();              // stop transmitting
       } 
      
      Serial.print( "\n" );
      Serial.print( "\tVoltage: " );
      Serial.print( current_Volts );        //Calculation and Value display is done      
     }
   }
 }
